% Przyklad 9.2:
% m-plik: przyklad_9_2.m
%
% Cyfrowe przetwarzanie sygnalow. Podstawy, multimedia, transmisja. PWN, Warszawa, 2014.
% Rozdzial 9: Przetworniki analogowo-cyfrowe i cyfrowo-analogowe.
% Autorzy rozdzialu: Wojciech Polchlopek, Roman Rumian.
%
% Wiecej na stronie internetowej: http://teledsp.kt.agh.edu.pl
%
% Opracowanie przykladu: marzec 2014 r.

clc; clear; close all;

b=12; q=2^(-(b-1));         % liczba bitow przetwornika A/C i krok kwantyzacji;
N=2^12;                     % dlugosc ciagu modelujacego szum kwantyzacji;
xn=(rand(N,1)-0.5)*q;       % generowanie "szumu kwantyzacji";
h= [1, -1];                 % odpowiedz impulsowa modulatora sigma delta w modelu z czasem-dyskretnym (filtr FIR);
y1=filter(h,1,xn);          % modulator I rzedu;
y2=filter(h,1,y1);          % modulator II rzedu;
y3=filter(h,1,y2);          % modulator III rzedu;
y4=filter(h,1,y2);          % modulator IV rzedu;

% wyznaczamy charakterystyki czestotliwosciowe (DFT) szumu wejsciowego oraz na wyjsciach modulatorow:
fpr=4e6; f=0:fpr/N:fpr/N*(N-1);
Xn=fft(xn); AXn_dB=20*log10(abs(Xn)+eps);
Y1=fft(y1); AY1_dB=20*log10(abs(Y1)+eps);
Y2=fft(y2); AY2_dB=20*log10(abs(Y2)+eps);
Y3=fft(y3); AY3_dB=20*log10(abs(Y3)+eps);

% Wykresy charakterystyk amplitudowych szumow na wyjsciach modulatorow:
    figure(1); axis_v=[0,fpr/2/1e6,-100,-20];
        subplot(4,1,1); plot(f/1e6,AXn_dB,'b');  grid on;
                             title('DFT szumu kwantyzacji');           ylabel('Amplituda(dB)');    xlabel('f[MHz]');
                             axis(axis_v);
        subplot(4,1,2); plot(f/1e6,AY1_dB,'b');  grid on;
                             ylabel('Amplituda(dB)');     xlabel('f[MHz]');
                             legend('DFT szumu po modulatorze S-D I rz.',4);   
                                                  axis(axis_v);
        subplot(4,1,3); plot(f/1e6,AY2_dB,'b');  grid on;
                             ylabel('Amplituda(dB)');    xlabel('f[MHz]');
                             legend('DFT szumu po modulatorze S-D II rz.',4);
                             axis(axis_v);                             
        subplot(4,1,4); plot(f/1e6,AY3_dB,'b');  grid on;
                             ylabel('Amplituda(dB)');    xlabel('f[MHz]');
                             legend('DFT szumu po modulatorze S-D III rz.',4);
                             axis(axis_v);                             

% KONIEC PRZYKLADU 9.2.